'by Steven
'assembles program

CONST
  maxLabels=20
  labelLength=5
  
VAR
  long destflag[16]  'whether each destination is an address or a label
  long sourceflag[16] 'as above but for source
  'long labelflag[16]  'whether each line has a label
  long valueflag[16]  'whether each is a value
  long program[512] 'for storing our program in
  byte labelText[(labelLength+1)*maxLabels] 'space for storing label text
  word labelAddress[maxLabels] 'the address where the label is
  byte numLabels

PUB startProgram|temp
  repeat temp from 0 to 511
    if checkIfDestLabel(temp)
      newDest(temp,labelAddress[getDest(temp)])
    if checkIfSourceLabel(temp)
      newSource(temp,labelAddress[getSource(temp)])
  repeat temp from 0 to 16-1
    destflag[temp]:=0
    sourceflag[temp]:=0  
  return cognew(@program,0)

PUB newLabel(linenum,label)|temp,temp1
  'check if label for that linenum already exists
  if numLabels>maxLabels
    return
  temp1:=numLabels
  repeat temp from 0 to numLabels-1
    if linenum==labelAddress[temp]
      temp1:=temp
  'make address right
  labelAddress[temp1]:=linenum
  'make string right
  repeat temp from 0 to labelLength+1
    labelText[temp1*(labelLength+1)+temp]:=byte[label][temp]
  'increment numlabels
  numLabels++
  
PUB getLabel(linenum)|temp
  repeat temp from 0 to numLabels-1
    if labelAddress[temp]==linenum
          return @labelText[(labelLength+1)*temp]
  return 0 'string can't start at 0 in hub memory, so 0 means no label
            
PUB getDest(linenum)
  return (program[linenum]>>9)&$1FF

PUB getDestLabel(linenum)
  return @labelText[(labelLength+1)*getDest(linenum)]

PUB checkIfDestLabel(linenum)
  if destflag[linenum/16]&(|<(linenum//16))==|<(linenum//16)
    return true
  return false

PUB newDest(linenum,destination)
  destination:=destination<<9
  program[linenum]:=program[linenum]&%11111111111111000000000111111111
  program[linenum]:=program[linenum]|destination

PUB numLabel
  return numLabels
  
PUB newDestLabel(linenum,label)|temp
  repeat temp from 0 to numLabels-1
    if strcomp(label,@labelText[(labelLength+1)*temp])
      newDest(linenum,temp)
      destflag[linenum/16]:=destflag[linenum/16]|(|<(linenum//16))
      return

PUB getSourceLabel(linenum)
  return @labelText[(labelLength+1)*getSource(linenum)]

PUB checkIfSourceLabel(linenum)
  if sourceflag[linenum/16]&(|<(linenum//16))==|<(linenum//16)
    return true
  return false

PUB newSourceLabel(linenum,label)|temp
  repeat temp from 0 to numLabels-1
    if strcomp(label,@labelText[(labelLength+1)*temp])
      newSource(linenum,temp)
      sourceflag[linenum/16]:=sourceflag[linenum/16]|(|<(linenum//16))
      return

PUB getSource(linenum)
  return program[linenum]&$1FF

PUB newSource(linenum,source)
  program[linenum]:=program[linenum]&%11111111111111111111111000000000
  program[linenum]:=program[linenum]|source

PUB getzcri(linenum)
  return (program[linenum]>>22)&$F

PUB newZcri(linenum,zcri)
  zcri:=zcri<<22
  program[linenum]:=program[linenum]&%11111100001111111111111111111111
  program[linenum]:=program[linenum]|zcri

PUB getCondition(linenum)
  return (program[linenum]>>18)&$F

PUB newCondition(linenum,cond)
  cond:=cond<<18
  program[linenum]:=program[linenum]&%11111111110000111111111111111111
  program[linenum]:=program[linenum]|cond

PUB getInst(linenum)
  return program[linenum]>>constant(32-6)

PUB newInst(linenum,inst)
  inst:=inst<<26         'shift to the rigt place
  program[linenum]:=program[linenum]&%00000011111111111111111111111111  'set instruction bits to 0
  program[linenum]:=program[linenum]|inst            'put in the instruction

PUB checkIfValue(linenum)
  if valueflag[linenum/16]&(|<(linenum//16))==|<(linenum//16)
    return true
  return false
  
PUB switchValueView(linenum)
  valueflag[linenum/16]:=valueflag[linenum/16]^(|<(linenum//16))
  
PUB getValue(linenum)
  return program[linenum]

PUB newValue(linenum,value)
  program[linenum]:=value
  valueflag[linenum/16]:=valueflag[linenum/16]|(|<(linenum//16))

  